#define PinAL 13               // контат AB
#define PinCL 12               // контат BC

uint8_t pinAL = 0;             // состояние контата AB
uint8_t pinCL = 0;             // состояние контата BC

uint8_t blockAL = false;       // блокировка прерывания на контакте AB
uint8_t blockCL = false;       // блокировка прерывания на контакте BC

uint8_t encoderResultL = 0;    // Результирующая переменная
int16_t encoderCountL = 0;     // Счетчик щелчков энкодера
int16_t oldencoderCountL = 0;  // Счетчик старое значение

void encoderFilterL () {
  encoderResultL = encoderResultL & B00001111;
  if (encoderResultL == B1011) encoderCountL ++;  // по часовой стрелке
  if (encoderResultL == B0111) encoderCountL --;  // против часосовой стрелки
}

void pinALCHANGEL () {          // Изменилось состояние контакта АB
  if (blockAL == true) return;
  pinAL = !digitalRead(PinAL);
  pinCL = !digitalRead(PinCL);
  encoderResultL  <<= 1;
  bitWrite(encoderResultL, 0, pinAL);
  encoderResultL  <<= 1;
  bitWrite(encoderResultL, 0, pinCL);
  encoderFilterL();
  if (!pinAL && !pinCL) blockAL = false; else blockAL = true;
  blockCL = false;
}

void pinCLCHANGEL () {          // Изменилось состояние контакта BC
  if (blockCL == true) return;
  pinAL = !digitalRead(PinAL);
  pinCL = !digitalRead(PinCL);
  encoderResultL  <<= 1;
  bitWrite(encoderResultL, 0, pinAL);
  encoderResultL  <<= 1;
  bitWrite(encoderResultL, 0, pinCL);
  encoderFilterL();
  if (!pinAL && !pinCL) blockCL = false; else blockCL = true;
  blockAL = false;
}

void encoderLinit() {
  pinMode (PinAL, INPUT_PULLUP);   // Как вход и внутренняя подтяжка
  pinMode (PinCL, INPUT_PULLUP);   // Как вход и внутренняя подтяжка
  attachInterrupt(digitalPinToInterrupt(PinAL), pinALCHANGEL, CHANGE);
  attachInterrupt(digitalPinToInterrupt(PinCL), pinCLCHANGEL, CHANGE);
}
