#define PinAR 33               // контат AB
#define PinCR 32               // контат BC

uint8_t pinAR = 0;             // состояние контата AB
uint8_t pinCR = 0;             // состояние контата BC

uint8_t blockAR = false;       // блокировка прерывания на контакте AB
uint8_t blockCR = false;       // блокировка прерывания на контакте BC

uint8_t encoderResultR = 0;    // Результирующая переменная
int16_t encoderCountR = 0;     // Счетчик щелчков энкодера
int16_t oldencoderCountR = 0;  // Счетчик старое значение

void encoderFilterR () {
  encoderResultR = encoderResultR & B00001111;
  if (encoderResultR == B1011) encoderCountR ++;  // по часовой стрелке
  if (encoderResultR == B0111) encoderCountR --;  // против часосовой стрелки
}

void pinARCHANGER () {          // Изменилось состояние контакта АB
  if (blockAR == true) return;
  pinAR = !digitalRead(PinAR);
  pinCR = !digitalRead(PinCR);
  encoderResultR  <<= 1;
  bitWrite(encoderResultR, 0, pinAR);
  encoderResultR  <<= 1;
  bitWrite(encoderResultR, 0, pinCR);
  encoderFilterR();
  if (!pinAR && !pinCR) blockAR = false; else blockAR = true;
  blockCR = false;
}

void pinCRCHANGER () {          // Изменилось состояние контакта BC
  if (blockCR == true) return;
  pinAR = !digitalRead(PinAR);
  pinCR = !digitalRead(PinCR);
  encoderResultR  <<= 1;
  bitWrite(encoderResultR, 0, pinAR);
  encoderResultR  <<= 1;
  bitWrite(encoderResultR, 0, pinCR);
  encoderFilterR();
  if (!pinAR && !pinCR) blockCR = false; else blockCR = true;
  blockAR = false;
}

void encoderRinit() {
  pinMode (PinAR, INPUT_PULLUP);   // Как вход и внутренняя подтяжка
  pinMode (PinCR, INPUT_PULLUP);   // Как вход и внутренняя подтяжка
  attachInterrupt(digitalPinToInterrupt(PinAR), pinARCHANGER, CHANGE);
  attachInterrupt(digitalPinToInterrupt(PinCR), pinCRCHANGER, CHANGE);
}
